package org.jboss.infinispan.test;

import java.io.IOException;

import org.apache.log4j.Logger;
import org.infinispan.Cache;
import org.infinispan.manager.DefaultCacheManager;
import org.infinispan.marshall.jboss.GenericJBossMarshaller;
import org.infinispan.util.ByteArrayKey;
import org.jboss.aop.microcontainer.aspects.jmx.JMX;

@JMX(exposedInterface=TestBean1MBean.class, registerDirectly=true)
public class TestBean1 implements TestBean1MBean {
	private static Logger LOG = Logger.getLogger(TestBean1.class);
	private DefaultCacheManager cacheManager = null;
	
	private ByteArrayKey createKey(String aKey) throws IOException {
		GenericJBossMarshaller m = new GenericJBossMarshaller();
		return new ByteArrayKey(m.objectToByteBuffer(aKey, aKey.length()));
	}
	
	public void loadData(DefaultCacheManager cacheManager) {
		LOG.info("Loading test data into Default Cache.");
		this.cacheManager = cacheManager;
		Cache<Object, Object> cache = cacheManager.getCache();
		cache.put("InfinispanRESTServerTestBean1_key1", "data");
		try {
			cache.put(createKey("InfinispanRESTServerTestBean1_key2"), "data");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
	
	public void removeData() {
		if (cacheManager != null) {
			LOG.info("Cleaning test data from Default Cache.");
			Cache<String, Object> cache = cacheManager.getCache();
			cache.remove("InfinispanRESTServerTestBean1_key1");
			cache.remove("InfinispanRESTServerTestBean1_key2");
		}
	}
	
	public void printKey(String key) {
		Cache<String, Object> cache = cacheManager.getCache();
		LOG.info("InVM GET(" + key + ") = " + cache.get(key));
	}
}
